#ifndef _AUTOX_TRACK_H

#include "track.h"
#include "scenegraph.h"

using namespace std;

class AUTOX_TRACK: public TRACK
{
private:
	bool open_track; // true-open track, false-closed(loop) track
	VERTEX field_origin;
	float field_width, field_height;

	void CalcStart();
	void CreateRoad();

	//utility function to convert cone position from map coordinates
	// (between 0.0 to 1.0) to real world coordinates
	VERTEX Map2Field(VERTEX *pos);

public:
	AUTOX_TRACK() : TRACK() { open_track = true; };
	~AUTOX_TRACK();
	vector<VERTEX*> cones;
	void ToggleOpenClose() { open_track = !open_track; };
	bool isOpenTrack() { return open_track; }
	void Load(string trackname, bool reverse);
	void CreateCones();

};

#define _AUTOX_TRACK_H
#endif /* _AUTOX_TRACK_H */
