/***************************************************************************
 *            track.cc
 *
 *  Sat Nov 19 11:08:52 2005
 *  Copyright  2005  Joe Venzon
 *  joe@venzon.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include "track.h"
#include "singleton.h"
#include "unittest.h"
#include "game.h"
#include "k1999.h"
extern GAME game;

ROADSTRIP::ROADSTRIP()
{
	//patchnodes = NULL;
}

void ROADSTRIP::ClearPatches()
{
	patchnodes.clear();
}

BEZIER * ROADSTRIP::Add(BEZIER & newpatch)
{
	/*BEZIERNODE * lastnode = NULL;
	BEZIERNODE * curnode = patchnodes;
	
	while (curnode != NULL)
	{
		lastnode = curnode;
		curnode = curnode->next;
	}

	//only continue if there is a last node and it really is the last node
	if (lastnode != NULL && lastnode->next == NULL)
	{
		lastnode->next = new BEZIERNODE;
		lastnode->next->patch.CopyFrom(newpatch);
		
		//optional....
		lastnode->patch.Attach(lastnode->next->patch);
		return &(lastnode->next->patch);
	}
	
	if (patchnodes == NULL)
	{
		patchnodes = new BEZIERNODE;
		patchnodes->patch.CopyFrom(newpatch);
		return &(patchnodes->patch);
	}
	
	return NULL;*/
	
	BEZIER * lastnode = NULL;
	if (!patchnodes.empty())
	{
		lastnode = &(patchnodes.back().GetPatch());
	}
	patchnodes.push_back(BEZIERNODE(newpatch));
	if (lastnode != NULL)
	{
		//cout << lastnode << " attaches to " << &(patchnodes.back()) << endl;
		lastnode->Attach(patchnodes.back().GetPatch());
	}
	return &(patchnodes.back().GetPatch());
}

BEZIER * ROADSTRIP::AddNew()
{
	BEZIER newpatch;
	return Add(newpatch);
}

bool ROADSTRIP::ReadFrom(ifstream &openfile)
{
	//optional....
	ClearPatches();
	
	if (!openfile)
		return false;
	
	BEZIER * newpatch = NULL;
	
	int num;
	
	//the number of patches for this road
	openfile >> num;
	
	int i;
	
	int badcount = 0;
	
	for (i = 0; i < num; i++)
	{
		BEZIER temppatch;
		//create a new patch and make it read from the file
		if (!temppatch.ReadFrom(openfile))
			return false;
		newpatch = Add(temppatch);
		if (newpatch->CheckForProblems())
		{
			badcount++;
			//cout << i << endl;
		}
	}
	
	//if (badcount > 0) cout << badcount << " of " << num << " bezier patches have problems." << endl;
	
	if (num > 2 && newpatch != NULL)
	{
		//cout << "close track?  " << num << " - " << newpatch << " - " << newpatch->next_patch << endl;
		newpatch->next_patch = NULL;
		//close a looped track
		//if (newpatch->points[0][0].equals(GetFirstPatch()->points[3][0]) && newpatch->points[0][3].equals(GetFirstPatch()->points[3][3]))
		if (((newpatch->points[0][0] - GetFirstPatch()->points[3][0]).len() < 0.1) && 
			((newpatch->points[0][3] - GetFirstPatch()->points[3][3]).len() < 0.1))
		{
			//cout << "closed track " << num << " - " << newpatch << " - " << newpatch->next_patch << endl;
			newpatch->Attach(*GetFirstPatch());
		}
	}
	
	GenerateCollisionData();
	
	return true;
}

bool ROADSTRIP::WriteTo(ofstream &openfile)
{
	openfile << NumPatches() << endl << endl;
		
	/*BEZIERNODE * curnode = patchnodes;
	
	while (curnode != NULL)
	{
		curnode->patch.WriteTo(openfile);
		openfile << endl;
		
		curnode = curnode->next;
	}*/
	
	for (list <BEZIERNODE>::iterator i = patchnodes.begin(); i != patchnodes.end(); i++)
	{
		i->GetPatch().WriteTo(openfile);
	}
	
	return true;
}

int ROADSTRIP::NumPatches()
{
	/*BEZIERNODE * curnode = patchnodes;
	
	int num = 0;
	
	while (curnode != NULL)
	{
		num++;
		
		curnode = curnode->next;
	}
	
	return num;*/
	
	return patchnodes.size();
}

bool ROADSTRIP::DeleteLastPatch()
{
	/*BEZIERNODE * lastnode = NULL;
	BEZIERNODE * prevlastnode = NULL;
	BEZIERNODE * curnode = patchnodes;
	
	while (curnode != NULL)
	{
		prevlastnode = lastnode;
		lastnode = curnode;
		curnode = curnode->next;
	}

	//only continue if there is a last node and it really is the last node
	if (lastnode != NULL && lastnode->next == NULL)
	{
		if (prevlastnode != NULL)
		{
			delete prevlastnode->next;
			prevlastnode->next = NULL;
			return true;
		}
		else
		{
			delete patchnodes;
			patchnodes = NULL;
			return true;
		}
	}
	
	return false;*/
	
	if (patchnodes.empty())
		return false;
	
	patchnodes.pop_back();
	return true;
}

BEZIER * ROADSTRIP::GetLastPatch()
{
	/*BEZIERNODE * lastnode = NULL;
	BEZIERNODE * prevlastnode = NULL;
	BEZIERNODE * curnode = patchnodes;
	
	while (curnode != NULL)
	{
		prevlastnode = lastnode;
		lastnode = curnode;
		curnode = curnode->next;
	}

	//only continue if there is a last node and it really is the last node
	if (lastnode != NULL && lastnode->next == NULL)
	{
		if (prevlastnode != NULL)
		{
			return &(prevlastnode->next->patch);
		}
		else
		{
			return &(patchnodes->patch);
		}
	}
	
	return NULL;*/
	
	if (patchnodes.empty())
		return NULL;
	return &(patchnodes.back().GetPatch());
}

void ROADSTRIP::Visualize (bool wireframe, bool fill, VERTEX color)
{
	CAMERA & cam = game.cam;
	
	//int tot = 0;
	
	//BEZIERNODE * curnode = patchnodes;
	
	/*while (curnode != NULL)
	{
		if (tot < 50) curnode->patch.Visualize(wireframe, fill, color);
		curnode = curnode->next;
		tot ++;
	}
	
	curnode = patchnodes;*/
	
	int count = 0;
	int drawn = 0;
	
	for (list <BEZIERNODE>::iterator curnode = patchnodes.begin(); curnode != patchnodes.end(); curnode++)
	{
		//i->WriteTo(openfile);
	//}
	//while (curnode != NULL)
	//{
		//if (tot - count < 50)
		bool drawme = true;
		//VERTEX pos = curnode->patch.center+cam.position;
		VERTEX & pos = curnode->GetPatch().center;
		for (int i=0;i<6;i++) 
		{
			float rd=cam.frustum[i][0]*pos.x+
			   cam.frustum[i][1]*pos.y+
			   cam.frustum[i][2]*pos.z+
			   cam.frustum[i][3];
			if (rd<=-curnode->GetPatch().radius)
			{
				drawme = false;
			}
		}
		
		if (drawme)
		{
			curnode->GetPatch().Visualize(wireframe, fill, color);
			drawn++;
		}
		
		//curnode = curnode->next;
		count++;
	}
	
	//cout << drawn << "/" << count << endl;
}

bool ROADSTRIP::Collide(VERTEX origin, VERTEX direction, float seglen, VERTEX &outtri, BEZIER * & colpatch, VERTEX & normal)
{
	bool col = false;
	
	colpatch = NULL;

	PHYSICSCOLLISIONSETTINGS settings;
	settings.SetRoadCollide(true);
	list <PHYSICSCONTACT> contacts;
	
	VERTEX origin_obj = origin;
	VERTEX dir_obj = direction;
	
	game.physics.CollideRay(origin_obj, dir_obj, seglen, contacts, settings);
	if (!contacts.empty())
	{
		col = true;
		contacts.sort(); //puts the closest (smallest distance) collision in front (ray-specific behavior)
		outtri = contacts.front().GetContactPosition();
		normal = contacts.front().GetContactNormal();
		
		colpatch = reinterpret_cast <BEZIER *> (contacts.front().GetCollidingObject1());
	}
	
	return col;
}

void ROADSTRIP::GenerateCollisionData()
{
	//cout << "Generating road collision data... " << endl;
	
	for (list <BEZIERNODE>::iterator i = patchnodes.begin(); i != patchnodes.end(); i++)
	{
		//argument below is the number of subdivisions
		//a higher number increases memory usage, but improves road smoothness
		i->GenerateCollisionData(6);
	}
	
	//cout << "done" << endl;
	
	for (list <BEZIERNODE>::iterator i = patchnodes.begin(); i != patchnodes.end(); i++)
	{
		i->RegisterCollisionData();
	}
}

void BEZIERNODE::GenerateCollisionData(const int d)
{
	fcount = d*d*2;
	vcount = (d+1)*(d+1);
	vertices = new PHYSICSOBJECTVERTEX[vcount];
	faces = new PHYSICSOBJECTFACE[fcount];
	
	//build vertices
	for (int y = 0; y < d+1; y++)
	{
		for (int x = 0; x < d+1; x++)
		{
			float yc = (float) y/d;
			float xc = (float) x/d;
			float * v = vertices[x+(d+1)*y].vertex;
			VERTEX vert(patch.SurfCoord(1.0-xc, 1.0-yc));
			v[0] = vert.x;
			v[1] = vert.y;
			v[2] = vert.z;
		}
	}
	
	//build faces
	for (int y = 0; y < d; y++)
	{
		for (int x = 0; x < d; x++)
		{
			int * f = faces[x*2+d*2*y].index;
			f[0] = x+(d+1)*y;
			f[1] = x+1+(d+1)*y;
			f[2] = x+1+(d+1)*(y+1);
			
			f = faces[x*2+d*2*y+1].index;
			f[0] = x+(d+1)*y;
			f[1] = x+1+(d+1)*(y+1);
			f[2] = x+(d+1)*(y+1);
		}
	}
}

void BEZIERNODE::RegisterCollisionData()
{
	physicsobject.SetPtr(game.physics.NewPhysicsObject());
	
	PHYSICSOBJECTSETTINGS settings;
	settings.SetRoadObject(true);
	//settings.SetObjectID(physicsobject.GetPtr());
	settings.SetObjectID(&patch);
	//physicsobject.GetPtr()->InitTrimesh((void *) vertices, 3*sizeof(float), vcount, (void *) faces, fcount*3, 3*sizeof(int), NULL, settings);
	physicsobject.GetPtr()->InitTrimesh((void *) vertices, 3*sizeof(float), vcount, (void *) faces, fcount*3, 3*sizeof(int), NULL, settings);
}

void BEZIERNODE::ClearCollisionData()
{
	if (vertices != NULL)
		delete [] vertices;
	if (faces != NULL)
		delete [] faces;
	fcount = 0;
	vcount = 0;
	vertices = NULL;
	faces = NULL;
	if (physicsobject.PtrValid())
		game.physics.DeletePhysicsObject(physicsobject.GetPtr());
}

//----------------- TRACK --------------


TRACK::TRACK()
{
	roads = NULL;
	lastelev = -100;
	verticaltrackingskyboxes = false;
	direction = true;
}

TRACK::~TRACK()
{
	ClearRoads();
}

void TRACK::ClearRoads()
{
	while (roads != NULL)
	{
		ROADSTRIPNODE * oldfirst = roads;
		roads = roads->next;
		delete oldfirst;
	}
}

ROADSTRIP * TRACK::AddNewRoad()
{
	/*ROADSTRIPNODE * oldfirst = roads;
	roads = new ROADSTRIPNODE;
	roads->next = oldfirst;
	
	return &(roads->road);*/
	
	ROADSTRIPNODE * lastnode = NULL;
	ROADSTRIPNODE * curnode = roads;
	
	while (curnode != NULL)
	{
		lastnode = curnode;
		curnode = curnode->next;
	}

	//only continue if there is a last node and it really is the last node
	if (lastnode != NULL && lastnode->next == NULL)
	{
		lastnode->next = new ROADSTRIPNODE;
		//lastnode->next->patch.CopyFrom(newpatch);
		
		//optional....
		//lastnode->patch.Attach(lastnode->next->patch);
		return &(lastnode->next->road);
	}
	
	if (roads == NULL)
	{
		roads = new ROADSTRIPNODE;
		return &(roads->road);
	}
	
	return NULL;
}

void TRACK::VisualizeRoads(bool wireframe, bool fill, ROADSTRIP * selectedroad)
{
	ROADSTRIPNODE * curnode = roads;
	
	VERTEX color;
	color.zero();
	color.z = 1;
	
	//game.utility.seedrandom(1234);
	
	while (curnode != NULL)
	{
		/*//randomize color!
		color.x = game.utility.randf(0.0,1.0);
		color.y = game.utility.randf(0.0,1.0);
		color.z = game.utility.randf(0.0,1.0);
		
		if (color.len() < 0.1)
		{
			color.y = 1.0;
		}
		
		float maxval = 0.0;
		if (color.x > maxval)
			maxval = color.x;
		if (color.y > maxval)
			maxval = color.y;
		if (color.z > maxval)
			maxval = color.z;
		
		color.x = (1.0/maxval)*color.x;
		color.y = (1.0/maxval)*color.y;
		color.z = (1.0/maxval)*color.z;*/
		
		color.zero();
		if (&(curnode->road) == selectedroad)
			color.y = 1;
		else
		{
			color.y = 0.5;
			color.z = 0.5;
		}
		
		curnode->road.Visualize(wireframe, fill, color);
		curnode = curnode->next;
	}
}

void TRACK::Write(string trackname)
{
	ofstream trackfile;
	trackfile.open((game.settings.GetDataDir() + "/tracks/" + trackname + "/roads.trk").c_str());
	
	VERTEX sl = GetStart(0); //to do - create a proper loop
	trackfile << sl.x << " " << sl.y << " " << sl.z << endl << endl;
	
	trackfile << NumRoads() << endl << endl;
	
	ROADSTRIPNODE * curnode = roads;
	
	while (curnode != NULL && trackfile)
	{
		curnode->road.WriteTo(trackfile);
		curnode = curnode->next;
	}
}

int TRACK::NumRoads()
{
	ROADSTRIPNODE * curnode = roads;
	
	int num = 0;
	
	while (curnode != NULL)
	{
		num++;
		curnode = curnode->next;
	}
	
	return num;
}

void TRACK::Load(string trackname, bool reverse)
{
	ifstream trackfile;
	trackfile.open((game.settings.GetDataDir() + "/tracks/" + trackname + "/roads.trk").c_str());
	
	CONFIGFILE trackconfig;
	trackconfig.Load((game.settings.GetDataDir() + "/tracks/" + trackname + "/track.txt").c_str());
	float tvert[3];
	VERTEX sl;
	int index = 0;
	bool end_of_position = false;
	startloc.clear();
	trackconfig.SuppressError(true); //suppress error message 
	while (!end_of_position)
	{
		std::stringstream s;
		s<<"start position "<<index;
		if (trackconfig.GetParam(s.str(), tvert))
		{
			sl.Set(tvert);
			SetStart(sl);
			index++;
		}
		else end_of_position = true;
	}
	trackconfig.SuppressError(false); //turn error message back on

	if (index == 0) //still using the old format
	{
		trackconfig.GetParam("start position", tvert);	
		sl.Set(tvert);
		SetStart(sl);
	}

	string strcullfaces;
	trackconfig.GetParam("cull faces", strcullfaces);
	//sl.Set(tvert);
	
	if (strcullfaces == "no")
		cullfaces = false;
	else
		cullfaces = true;
	
	//string strhoriz;
	bool vertsky = false;
	//trackconfig.GetParam("vertical tracking skyboxes", strhoriz);
	trackconfig.GetParam("vertical tracking skyboxes", vertsky);
	verticaltrackingskyboxes = vertsky;
	//cout << "Vertical tracking skyboxes: " << vertsky << endl;
	//if (strhoriz == "no")
	//if (vertsky)
	//	verticaltrackingskyboxes = false;
	//else
	//	verticaltrackingskyboxes = true;
	game.objects.SetVerticalSkyboxTracking(verticaltrackingskyboxes);
	
	int numroads, i;
	
	/*trackfile >> sl.x;
	trackfile >> sl.y;
	trackfile >> sl.z;*/
	
	//SetStart(sl);
	
	index = 0;
	end_of_position = false;
	startquat.clear();
	VERTEX sov;
	float w;
	trackconfig.SuppressError(true); //suppress error message 
	while (!end_of_position)
	{
		std::stringstream s1,s2;
		s1<<"start orientation-xyz "<<index;
		s2<<"start orientation-w "<<index;
		if (trackconfig.GetParam(s1.str(), tvert) &&
		    trackconfig.GetParam(s2.str(), w))
		{
			sov.Set(tvert);
			QUATERNION so;
			so.x = sov.x;
			so.y = sov.y;
			so.z = sov.z;
			so.w = w;
			SetStartOrientation(so);
			index++;
		}
		else end_of_position = true;
	}
	trackconfig.SuppressError(false); //turn error message back on

	if (index == 0) //still using the old format
	{
		trackconfig.GetParam("start orientation-xyz", tvert);
		sov.Set(tvert);
		QUATERNION so;
		so.x = sov.x;
		so.y = sov.y;
		so.z = sov.z;
		trackconfig.GetParam("start orientation-w", so.w);
		SetStartOrientation(so);
	}
	
	if (trackfile)
	{
		trackfile >> numroads;
	}
	else
	{
		cout << "No track named " << trackname << ", creating a new one." << endl;
		return;
	}
	
	ClearRoads();
	for (i = 0; i < numroads && trackfile; i++)
	{
		ROADSTRIP * newroad = AddNewRoad();
		newroad->ReadFrom(trackfile);
	}
	
	lapsequence.clear();
	int lapmarkers;
	if (trackconfig.GetParam("lap sequences", lapmarkers))
	{
		for (int l = 0; l < lapmarkers; l++)
		{
			float lapraw[3];
			stringstream lapname;
			lapname << "lap sequence " << l;
			trackconfig.GetParam(lapname.str(), lapraw);
			lapsequence.push_back(GetBezier((int) lapraw[0], (int) lapraw[1]));
		}
	}
	
	if (reverse)
	{
		Reverse();
		direction = false;
	}
	else direction = true;
	
	float f;
	trackconfig.GetParam("non-treaded friction coefficient", f);
	friction1 = f;
	trackconfig.GetParam("treaded friction coefficient", f);
	friction2 = f;

	// calculate distance from starting line for each patch to account for those tracks
	// where starting line is not on the 1st patch of the road
	// note this only update the road with lap sequence 0 on it
	BEZIER* start_patch = GetLapSequence(0);
	if (start_patch)
	{
		start_patch->dist_from_start = 0.0;
		BEZIER* curr_patch = start_patch->next_patch;
		float total_dist = start_patch->length;
		int count = 0;
		while ( curr_patch && curr_patch != start_patch)
		{
			count++;
			curr_patch->dist_from_start = total_dist;
			total_dist += curr_patch->length;
			curr_patch = curr_patch->next_patch;
		}
	}

	//Calculate racing line
	K1999 k1999data;
	ROADSTRIPNODE* roadstripnode = roads;
	for (i = 0; i < numroads; i++)
	{
		ROADSTRIP * newroad = &(roadstripnode->road);
		if (k1999data.LoadData(newroad))
		{
			k1999data.CalcRaceLine();
			k1999data.UpdateRoadStrip(newroad);
		}
		roadstripnode = roadstripnode->next;
	}
	
}

void TRACK::Delete(ROADSTRIP * striptodel)
{
	bool deleted = false;
	
	ROADSTRIPNODE * lastnode = NULL;
	ROADSTRIPNODE * curnode = roads;
	
	while (curnode != NULL)
	{
		/*
		NOTE THAT THE BACKSPACE BUTTON NEEDS TO CALL THIS (AND CLEAR 
		 ACTIVESTRIP TO NULL) TO ENSURE THERE ARE NO EMPTY ROADS!
		*/
		
		if (striptodel == &(curnode->road))
		{
			curnode = curnode->next;

			if (lastnode == NULL)
			{
				roads = curnode;
			}
			else
			{
				lastnode->next = curnode;
			}
			
			delete striptodel;
			
			deleted = true;
		}
		else
		{
			lastnode = curnode;
			curnode = curnode->next;
		}
	}
	
	//fail safe stuff
	if (!deleted)
		delete striptodel;
	
	striptodel = NULL;
}

bool TRACK::CollideRoads(VERTEX origin, VERTEX direction, float seglen, VERTEX &outtri, ROADSTRIP * &collideroad, BEZIER * & collidepatch, VERTEX & normal)
{
	ROADSTRIPNODE * curnode = roads;
	
	bool collide;
	bool hadcollision = false;
	VERTEX tvert;
	VERTEX tnorm;
	
	while (curnode != NULL)
	{
		//curnode->patch.Visualize(wireframe, fill, color);
		collide = curnode->road.Collide(origin, direction, seglen, tvert, collidepatch, tnorm);
		if (collide)
		{
			if ((hadcollision && (origin - tvert).len() < (origin - outtri).len()) || !hadcollision)
			{
				normal = tnorm;
				outtri = tvert;
				collideroad = &(curnode->road);
			}
			
			hadcollision = true;
		}
		
		curnode = curnode->next;
	}
	
	if (hadcollision)
	{
		return true;
	}
	
	outtri = origin;
	return false;
}

/*bool TRACK::Collide(VERTEX origin, VERTEX direction, float seglen, VERTEX &outtri, bool closest, VERTEX & normal, float & dist)
{
	bool verbose = false;
	
	bool col = false;

	dist = 0;
	
	VERTEX zero;
	
	if (direction.equals(zero))
		return false;
	
	direction = direction.normalize();
	
	//ROADSTRIP * colstrip;
	//BEZIER * colpatch;
	
	normal.Set(0,1,0);
	
		//check for a model collision
		//OBJECTNODE * tnode;
		//col = game.objects.Collide(origin, direction, outtri, closest, normal, seglen, tnode);
		col = false;
		//normal.Set(0,1,0);
		//normal.DebugPrint();
		if (col)
		{
			dist = (outtri - origin).len();
			if (dist > seglen)
				return false;
			if (verbose)
			{
				cout << "model collision: " << dist << endl;
				//lastorigin.DebugPrint();
				outtri.DebugPrint();
				cout << endl;
			}
		}
	//}
	
	//if (!col && verbose) cout << "no collision" << endl;

	//normal.DebugPrint();
	
	if (normal.nan())
	{
		cout << "Detected NaN in normal vector" << endl;
		normal.Set(0,1,0);
	}
	
	if (outtri.nan())
	{
		cout << "Detected NaN in collision point" << endl;
		outtri = origin;
	}
	
	if (!(dist <= 0 || dist > 0))
	{
		cout << "Detected NaN in collision distance" << endl;
		dist = 0;
	}
	
	return col;
}*/

double TRACK::Elevation(VERTEX origin)
{
	VERTEX normal;
	return Elevation(origin, normal);
}

double TRACK::Elevation(VERTEX origin, VERTEX & normal)
{
	origin.y += 1000;
	return ElevationSeg(origin, normal, 10000.0f);
}

double TRACK::ElevationSeg(VERTEX origin, VERTEX & normal, float seglen)
{
	BEZIER * colpatch;
	OBJECTNODE * colnode;
	return ElevationSeg(origin, normal, seglen, colpatch, colnode);
}

double TRACK::ElevationSeg(VERTEX origin, VERTEX & normal, float seglen, BEZIER * &colpatch, OBJECTNODE * &colnode)
{
	if (origin.nan())
	{
		//cout << "Detected NaN in origin vector" << endl;
		throw string( "Detected NaN in origin vector" );
	}
	
	if (!(seglen < 0 || seglen >= 0))
	{
		cout << "Detected NaN in seglen" << endl;
		throw string( "Detected NaN in seglen" );
	}
	
	bool verbose = false;
	
	//origin.y = 1000;
	VERTEX dir;
	dir.y = -1;
	double elev = -100000;
	VERTEX colpt;
	bool col = false;
	bool bezcol = false;
	bool modelcol = false;
	
	ROADSTRIP * colstrip;
	//BEZIER * colpatch;
	
	normal.Set(0,1,0);
	
	colnode = NULL;
	colpatch = NULL;
	
	col = CollideRoads(origin, dir, seglen, colpt, colstrip, colpatch, normal);
	
	//cout << "Origin: ";origin.DebugPrint();
	//cout << "Camera: ";game.cam.position.ScaleR(-1.0).DebugPrint();
	
	//if (Collide(origin, dir, colpt, true))
	//if (0)
	if (col)
	{
		bezcol = true;
		elev = colpt.y;
		
#ifdef LIBODE_OPCODE
#else
		normal.Scale(-1.0);
#endif
		
		//cout << "wheel collision point: ";colpt.DebugPrint();
		if (verbose) cout << "track collision with patch " << colpatch << endl;
	}
	else
	{
		colpatch = NULL;

		//col = objects.Collide(origin, dir, colpt, closest, normal, seglen, colnode);
		//cout << "Bezier collision: ";colpt.DebugPrint();
		
		PHYSICSCOLLISIONSETTINGS settings;
		settings.SetMapCollide(true);
		list <PHYSICSCONTACT> contacts;
		//const SCENENODE & objscene = game.objects.GetSceneNode();
		//VERTEX origin_obj = objscene.TransformIntoLocalSpace(origin);
		//VERTEX dir_obj = objscene.TransformIntoLocalSpace(dir);
		VERTEX origin_obj = origin;
		VERTEX dir_obj = dir;
		game.physics.CollideRay(origin_obj, dir_obj, seglen, contacts, settings);
		if (!contacts.empty())
		{
			col = true;
			contacts.sort(); //puts the closest (smallest distance) collision in front (ray-specific behavior)
			VERTEX outpt = contacts.front().GetContactPosition();
			VERTEX outnorm = contacts.front().GetContactNormal();
			//colpt = objscene.TransformIntoWorldSpace(outpt);
			//normal = objscene.TransformIntoWorldSpace(outnorm);
			colpt = outpt;
			normal = outnorm;
			//cout << "outnorm: ";outnorm.DebugPrint();
			//cout << "normal: ";normal.DebugPrint();
#ifdef LIBODE_OPCODE
#else
			normal.Scale(-1.0);
#endif
			//cout << "Collision objects: " << contacts.front().GetCollidingObject1() << ", " << contacts.front().GetCollidingObject2() << endl;
			//cout << "IsMap: " << contacts.front().GetCollidingObject1()->IsMapObject() << ", " << contacts.front().GetCollidingObject2()->IsMapObject << endl;
			colnode = reinterpret_cast <OBJECTNODE *> (contacts.front().GetCollidingObject1());
			if (verbose)
				cout << "Collision with " << colnode->model->name << endl;
			//cout << "ODE collision: ";outpt.DebugPrint();
		}
		
		if (col)
		{
			//cout << "TRACK::ELEVATION collision point=";colpt.DebugPrint();
			elev = colpt.y;
			modelcol = true;
		}
		else
			elev = origin.y - seglen;
	}
	
	if (!col && verbose)
		cout << "no collision" << endl;
	
	//normal.DebugPrint();
	
	if (col)
	{
		if (normal.nan())
		{
			//cout << "Detected NaN in normal vector " << bezcol << " " << modelcol << endl;
			std::ostringstream error;
			error << "Detected NaN in normal vector " << bezcol << " " << modelcol;
			throw string( error.str() );
			normal.Set(0,1,0);
		}
		
		if (!(elev < 0 || elev >= 0))
		{
			std::ostringstream error;
			error << "Detected NaN in elevation " << bezcol << " " << modelcol;
			throw string( error.str() );
			//cout << "Detected NaN in elevation " << bezcol << " " << modelcol << endl;
			return -100000;
		}
	}
	
	//cout << "TRACK::ELEVATION elev: " << elev << endl;
	
	return elev;
}

BEZIER * TRACK::GetPatch(VERTEX corners[4])
{
	ROADSTRIPNODE * curnode = roads;
	
	while (curnode != NULL)
	{
		//BEZIER * curpatch = curnode->road.GetFirstNode();
		for (list <BEZIERNODE>::iterator curpatch = curnode->road.patchnodes.begin(); curpatch != curnode->road.patchnodes.end(); curpatch++)
		//while (curpatch != NULL)
		{
			BEZIER & b(curpatch->GetPatch());
			if (b.points[0][0].equals(corners[0]) && 
				b.points[0][3].equals(corners[1]) && 
				b.points[3][0].equals(corners[2]) && 
				b.points[3][3].equals(corners[3]))
			{
				return &(b);
			}
			
			//curpatch = curpatch->next;
		}
		
		curnode = curnode->next;
	}
	
	return NULL;
}

BEZIER * TRACK::GetBezier(int ridx, int pidx)
{
	ROADSTRIPNODE * curnode = roads;
	
	int ri = 0;
	
	while (curnode != NULL)
	{
		if (ri == ridx)
		{
			//BEZIERNODE * curp = curnode->road.patchnodes;
			int pi = 0;
			
			//while (curp != NULL)
			for (list <BEZIERNODE>::iterator curpatch = curnode->road.patchnodes.begin(); curpatch != curnode->road.patchnodes.end(); curpatch++)
			{
				if (pidx == pi)
				{
					return &(curpatch->GetPatch());
				}
				
				pi++;
				//curp = curp->next;
			}
		}
		
		ri++;
		curnode = curnode->next;
	}
	
	cerr << "Error finding bezier for lap sequence in GetLapSeq(" << ridx << "," << pidx << ")" << endl;
	return NULL;
}

BEZIER * TRACK::GetLapSequence(int idx)
{
	if (idx < NumSectors() && idx >= 0)
		return lapsequence[idx];
	else return NULL;
}

void TRACK::Reverse()
{
	//move timing sector 0 back 1 patch
	if (lapsequence.size() > 0)
	{
		BEZIER * startingline = lapsequence[0];
		BEZIER * newstartingline = NULL;
		ROADSTRIPNODE * curnode = roads;
		
		while (curnode != NULL)
		{
			for (list <BEZIERNODE>::iterator curpatch = curnode->road.patchnodes.begin(); curpatch != curnode->road.patchnodes.end(); curpatch++)
			{
				list <BEZIERNODE>::iterator nextnode(curpatch);
				nextnode++;
				if (nextnode != curnode->road.patchnodes.end())
				{
					if (&nextnode->GetPatch() == startingline)
					{
						newstartingline = &(curpatch->GetPatch());
					}
				}
			}
			curnode = curnode->next;
		}
		
		if (newstartingline != NULL)
		{
			//cout << "SUCCESS" << endl;
			lapsequence[0] = newstartingline;
		}
	}
	
	//reverse start positions
	for (vector <QUATERNION>::iterator i = startquat.begin(); i != startquat.end(); i++)
	{
		//*i = i->ReturnConjugate();
		i->Rotate(3.141593, 0,1,0);
	}
	
	//reverse roads
	ROADSTRIPNODE * curnode = roads;
	//list <ROADSTRIPNODE *> roadlist;
	while (curnode != NULL)
	{
		//roadlist.push_back(curnode);
		curnode->road.Reverse();
		curnode = curnode->next;
	}
	/*roadlist.reverse();
	cout << roadlist.size() << endl;
	curnode = roads;
	for (list <ROADSTRIPNODE *>::iterator i = roadlist.begin(); i != roadlist.end(); i++)
	{
		curnode = *i;
		list <ROADSTRIPNODE *>::iterator nexti = i;
		nexti++;
		if (nexti == roadlist.end())
			curnode->next = NULL;
		else
			curnode->next = *nexti;
		
		if (curnode->next != NULL)
			curnode = curnode->next;
	}*/
	
	//reverse the timing sectors
	if (lapsequence.size() > 0)
	{
		list <BEZIER *> revlapsequence;
		for (unsigned int i = 0; i < lapsequence.size(); i++)
		{
			revlapsequence.push_back(lapsequence[i]);
		}
		revlapsequence.reverse();
		BEZIER * startpatch = revlapsequence.back();
		revlapsequence.pop_back();
		revlapsequence.push_front(startpatch);
		list <BEZIER *>::iterator li = revlapsequence.begin();
		for (unsigned int i = 0; i < lapsequence.size() && li != revlapsequence.end(); i++,li++)
		{
			lapsequence[i] = *li;
		}
	}
	
	ReverseStartingPositions();
}

void ROADSTRIP::Reverse()
{
	patchnodes.reverse();
	
	for (list <BEZIERNODE>::iterator i = patchnodes.begin(); i != patchnodes.end(); i++)
	{
		//i->Reverse();
		i->GetPatch().dist_from_start = 0.0;
	}
	
	//fix pointers to next patches for AI
	for (list <BEZIERNODE>::iterator i = patchnodes.begin(); i != patchnodes.end(); i++)
	{
		list <BEZIERNODE>::iterator n = i;
		n++;
		BEZIER * nextpatchptr = NULL;
		if (n != patchnodes.end())
		{
			nextpatchptr = &(n->GetPatch());
			i->GetPatch().Attach(*nextpatchptr, true);
		}
		else
			i->GetPatch().next_patch = nextpatchptr;
	}
}

void TRACK::ReverseStartingPositions()
{
	list <VERTEX> revloc;
	list <QUATERNION> revquat;
	
	for (vector <VERTEX>::iterator i = startloc.begin(); i != startloc.end(); i++)
		revloc.push_back(*i);
	revloc.reverse();
	startloc.clear();
	for (list <VERTEX>::iterator i = revloc.begin(); i != revloc.end(); i++)
		startloc.push_back(*i);
	
	for (vector <QUATERNION>::iterator i = startquat.begin(); i != startquat.end(); i++)
		revquat.push_back(*i);
	revquat.reverse();
	startquat.clear();
	for (list <QUATERNION>::iterator i = revquat.begin(); i != revquat.end(); i++)
		startquat.push_back(*i);
}

QT_TEST(beziernode_test)
{
	BEZIER b;
	
	VERTEX fl(-1,0,2),fr(1,0,2),bl(-1,0,0),br(1,0,0);
	b.SetFromCorners(fl,fr,bl,br);
	BEZIERNODE bn(b);
	bn.GenerateCollisionData(1);
	QT_CHECK_EQUAL(bn.GetCollisionNumFaces(),2);
	QT_CHECK_EQUAL(bn.GetCollisionNumVerts(),4);
	VERTEX v;
	v.Set(bn.GetCollisionVerts()[0].vertex);
	QT_CHECK_EQUAL(v,fl);
	v.Set(bn.GetCollisionVerts()[1].vertex);
	QT_CHECK_EQUAL(v,fr);
	v.Set(bn.GetCollisionVerts()[2].vertex);
	QT_CHECK_EQUAL(v,bl);
	v.Set(bn.GetCollisionVerts()[3].vertex);
	QT_CHECK_EQUAL(v,br);
	
	QT_CHECK_EQUAL(bn.GetCollisionFaces()[0].index[0],0);
	QT_CHECK_EQUAL(bn.GetCollisionFaces()[0].index[1],1);
	QT_CHECK_EQUAL(bn.GetCollisionFaces()[0].index[2],3);
	
	QT_CHECK_EQUAL(bn.GetCollisionFaces()[1].index[0],0);
	QT_CHECK_EQUAL(bn.GetCollisionFaces()[1].index[1],3);
	QT_CHECK_EQUAL(bn.GetCollisionFaces()[1].index[2],2);
}
